import com.burtbeckwith.hierarchicalroles.Role
import com.burtbeckwith.hierarchicalroles.User

class BootStrap {

	def passwordEncoder

     def init = { servletContext ->

		def adminRole = findOrCreateRole('ROLE_ADMIN')
		def superAdminRole = findOrCreateRole('ROLE_SUPERADMIN')
		def userRole = findOrCreateRole('ROLE_USER')

		findOrCreateUser('admin', adminRole)
		findOrCreateUser('superadmin', superAdminRole)
		findOrCreateUser('user', userRole)
	}

	def destroy = {}

	private Role findOrCreateRole(String name) {
		def role = Role.findByAuthority(name)
		if (!role) {
			role = new Role(description: name, authority: name).save()
		}
		role
	}

	private User findOrCreateUser(String username, Role role) {
		def user = User.findByUsername(username)
		if (!user) {
			String password = passwordEncoder.encodePassword(username, null)
			user = new User(username: username, passwd: password, enabled: true,
			                email: username + "@foo.com", userRealName: username).save()
			role.addToPeople(user)
			role.save(flush: true)
		}
		user
	}
}

